; Atari DOS values.
; License: GPL-2, see LICENSE
; Date Created: 2022-08-04
; (c) 2022 Mark Ormston <memso@memso.net>

.IFNDEF IncludeFile_AtariDOS
IncludeFile_AtariDOS = 1
.INCLUDE "AtariOS.inc"

; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Addresses
.SCOPE AtariDOS
	; VERY incomplete!

	; Page 2 ========================================================================================

	; Address, For DOS, this is the run address to start the program at. Often used by binary files to
	; tell DOS where to start.
	RUNAD = $2E0
.ENDSCOPE ; AtariDOS



; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Constants



; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macros

; *************************************************************************************************
; Defines the very first binary block for a DOS binary file (such as .COM).
; Parameters:
;   start           Word, The start address of the first binary block.
;   length          Word, The length of the first binary block, in bytes.
; Size: 6
.MACRO AtariDOS_BinaryStart start, length
	.WORD $FFFF
	AtariDOS_BinaryBlock start, length
.ENDMACRO



; *************************************************************************************************
; Defines where to load a binary file block.
; Parameters:
;   start           Word, The start address of the binary block.
;   length          Word, The length of the binary block, in bytes.
; Size: 4
.MACRO AtariDOS_BinaryBlock start, length
	.WORD start
	.WORD (start) + (length) - 1
.ENDMACRO

.ENDIF ; .IFNDEF IncludeFile_AtariDOS