; Helper for atarisio remote control
; License: GPL-2, see LICENSE
; This Version (c) 2022 Mark Ormston <memso@memso.net>
; Original copyright (c) 2019 by Matthias Reichl <hias@horus.com>

.INCLUDE "../Include/HISIO.inc"
.INCLUDE "../Include/CIO.inc"

; *************************************************************************************************
; ???
SWAP_DRIVES:
	LDX #<(PARAM_SWAP)
	LDY #>(PARAM_SWAP)
	JSR CALL_SIO
	BMI SWAP_FAILED

	LDX #<(PARAM_STATUS)
	LDY #>(PARAM_STATUS)
	JSR CALL_SIO
	BMI SWAP_FAILED
	LDA AtariOS::ZP_STATUS_BUF
	CMP #1
	BNE SWAP_FAILED

	LDX #<(PARAM_NOP)
	LDY #>(PARAM_NOP)
	JSR CALL_SIO

	BPUT 0, TSWAPOKL, TSWAPOK
	CLC
	RTS

SWAP_FAILED:
	BPUT 0, TSWAPERRL, TSWAPERR
	SEC
	RTS
; End SWAP_DRIVES



; *************************************************************************************************
; ???
CALL_SIO:
	STX TMPVEC
	STY TMPVEC + 1
	LDY #$0B
CALL_SIO_L1:
	LDA (TMPVEC),Y
	STA AtariOS::DCB,Y
	DEY
	BPL CALL_SIO_L1
	JMP AtariOS::SIOV
; End CALL_SIO



; *************************************************************************************************

PARAM_SWAP:
	.BYTE 'a'
	.BYTE 1
	.BYTE 'C'
	.BYTE $80
	.WORD SWAP_CMD
	.BYTE 7,0
	.WORD SWAP_CMD_L
	.WORD SWAP_CMD_L

SWAP_CMD:
	.BYTE "xc 1 2"
SWAP_CMD_L = * - SWAP_CMD

PARAM_STATUS:
	.BYTE 'a'
	.BYTE 1
	.BYTE 'S'
	.BYTE $40
	.WORD AtariOS::ZP_STATUS_BUF
	.BYTE 7,0
	.WORD 4
	.WORD 0

AtariOS::ZP_STATUS_BUF:
	.RES 4, 0

PARAM_NOP:
	.BYTE 'a'
	.BYTE 1
	.BYTE 'C'
	.BYTE $00
	.WORD AtariOS::ZP_STATUS_BUF
	.BYTE 7,0
	.WORD 0
	.WORD 0

TSWAPOK:
	.BYTE "swapped AtariSIO drives D1: and D2:",ATASCII::EndOfLine
TSWAPOKL = * - TSWAPOK

TSWAPERR:
	.BYTE "AtariSIO remote control failed",ATASCII::EndOfLine
TSWAPERRL = * - TSWAPERR

