; Highspeed SIO routine, base file
; License: GPL-2, see LICENSE
; This version (c) 2022 Mark Ormston <memso@memso.net>
; Original copyright (c) 2003-2009 by Matthias Reichl <hias@horus.com>
;
; NOTE: the code in Receive.asm (actually the part
; starting from "L_GETLP" up to the last "BNE L_GETLP") should
; not cross a page boundary, otherwise there's an increased
; chance for overruns at 126kbit/sec!
;
; You may arrange the code parts in different order, but be sure
; that "Check" and "Break" should be close to "Receive", the
; code in "Receive" branches to the L_ERR* labels in "Check" and
; in "Break".

.INCLUDE "../Include/HISIO.inc"


; *************************************************************************************************
; Optimized layout for MyPicoDos, starting at $092A
.IFDEF HISIO_MYPICODOS
	.INCLUDE "HISIO/Main.asm"
	.INCLUDE "HISIO/VBI.asm"
	.INCLUDE "HISIO/Check.asm"
	.INCLUDE "HISIO/Break.asm"
	.INCLUDE "HISIO/Receive.asm"
	.INCLUDE "HISIO/Cleanup.asm"
	.INCLUDE "HISIO/Send.asm"
	.INCLUDE "HISIO/Diag.asm"



; *************************************************************************************************
; Standard layout, works for:
; - highspeed SIO patch
; - relocatable code starting at $xx00
.ELSE
	.INCLUDE "HISIO/Main.asm"
	.INCLUDE "HISIO/Check.asm"
	.INCLUDE "HISIO/Break.asm"
	.INCLUDE "HISIO/Receive.asm"
	.INCLUDE "HISIO/Cleanup.asm"
	.INCLUDE "HISIO/Send.asm"
	.INCLUDE "HISIO/VBI.asm"
	.INCLUDE "HISIO/Diag.asm"
.ENDIF
