; Highspeed SIO test 
; License: GPL-2, see LICENSE
; This Version (c) 2022 Mark Ormston <memso@memso.net>
; Original Copyright (c) 2003 by Matthias Reichl <hias@horus.com>
.INCLUDE "../Include/HISIO.inc"

; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Constants

; Define this to access SIO at the Atari OS's standard vector.
;AccessSIOInOS = 1



; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Addresses

; Where this should start.
START	= $2000

; Where high speed SIO is located.
.IFDEF AccessSIOInOS
	HIGHSIO	= AtariOS::SIOV
.ELSE
	HIGHSIO	= $4000
.ENDIF



; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Main Code & Data

; !!! Making it work. This adds a DOS header for the main code
.ORG START - 6
AtariDOS_BinaryStart START, BUF - START

; *************************************************************************************************
; Set SIO parameters for D2: (this looks like D3 to me...)
;Start:
	LDA #'1'
	STA AtariOS::DDEVIC
	LDA #3
	STA AtariOS::DUNIT
	LDA #7
	STA AtariOS::DTIMLO

	; Fall through ------>
; End Start



; *************************************************************************************************
; Read sectors 256-511 in a loop forever
DOTEST:
	LDA #'R'
	STA AtariOS::DCOMND
	LDA #1
	STA AtariOS::DSEC + 1
	LDA #0
	STA AtariOS::DSEC
	STA AtariOS::DBYT + 1
	LDA #128
	STA AtariOS::DBYT

	LDA #<(BUF)
	STA AtariOS::DBUF
	LDA #>(BUF)
	STA AtariOS::DBUF + 1

TLOOP:
	LDA #$40
	STA AtariOS::DSTATS
	JSR HIGHSIO

	INC AtariOS::DSEC
	JMP TLOOP
; End DOTEST

BUF:



; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Store where the program starts for DOS

; !!! Making it work. Adds the start vector for DOS
.ORG AtariDOS::RUNAD
AtariDOS_BinaryBlock AtariDOS::RUNAD, 2
.WORD START
