; Short immediate VBI code for insane transfer speeds
; License: GPL-2, see LICENSE
; This Version (c) 2022 Mark Ormston <memso@memso.net>
; Original copyright (c) 2009 Matthias Reichl <hias@horus.com>

.INCLUDE "../Include/HISIO.inc"

; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Code and Data

; *************************************************************************************************
; Fast NMI.
FASTNMI:
	CLD
	PHA
	LDA AtariOS::ZP_CRITIC
	BEQ L_NOCRIT

	LDA ANTIC_R::NMIST
	STA ANTIC_W::NMIRES
	BMI L_IGNDLI

	; Update the real-time 24-bit value
	INC AtariOS::ZP_RTCLOK + 2
	BNE L_NOC1
	INC AtariOS::ZP_RTCLOK + 1
	BNE L_NOC1
	INC AtariOS::ZP_RTCLOK

L_NOC1:
	LDA AtariOS::CDTMV1
	BNE L_NOTI11
	LDA AtariOS::CDTMV1 + 1
	BEQ L_NOTI12
	DEC AtariOS::CDTMV1 + 1

L_NOTI11:
	DEC AtariOS::CDTMV1
	BNE L_NOTI12
	LDA AtariOS::CDTMV1 + 1
	BEQ L_RUNT1

L_NOTI12:
	PLA
	RTI

L_RUNT1:
	TXA
	PHA
	TYA
	PHA
	JSR L_RUNT11
	PLA
	TAY
	PLA
	TAX

L_IGNDLI:
	PLA
	RTI

L_NOCRIT:
	BIT ANTIC_R::NMIST
	BPL L_NODLI
	PLA
	JMP (AtariOS::VDSLST)

L_NODLI:
	TXA
	PHA
	TYA
	PHA
	STA ANTIC_W::NMIRES
	JMP (AtariOS::VVBLKI)

L_RUNT11:
	JMP (AtariOS::CDTMA1)
; End FASTNMI



; *************************************************************************************************
; Fast VBI.
FASTVBI:
	LDA AtariOS::ZP_CRITIC
	BEQ L_STDVB2

	; Update the real-time 24-bit value
	INC AtariOS::ZP_RTCLOK + 2
	BNE L_NOC2
	INC AtariOS::ZP_RTCLOK + 1
	BNE L_NOC2
	INC AtariOS::ZP_RTCLOK

L_NOC2:
	LDA AtariOS::CDTMV1
	BNE L_NOTI21
	LDA AtariOS::CDTMV1 + 1
	BEQ L_NOTI22
	DEC AtariOS::CDTMV1 + 1

L_NOTI21:
	DEC AtariOS::CDTMV1
	BNE L_NOTI22
	LDA AtariOS::CDTMV1 + 1
	BEQ L_RUNT2

L_NOTI22:
	JMP AtariOS::XITVBV

L_RUNT2:
	JSR L_RUNT11
	JMP AtariOS::XITVBV

L_STDVB2:
	JMP AtariOS::SYSVBV
; End FASTVBI
