; Highspeed SIO test for overrun
; License: GPL-2, see LICENSE
; This Version (c) 2022 Mark Ormston <memso@memso.net>
; Original copyright (c) by Matthias Reichl <hias@horus.com>

.INCLUDE "../Include/HISIO.inc"
.INCLUDE "../Include/CIO.inc"

; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Constants

DIAGSIO = 1



; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Addresses

; Where the program starts at.
START	= $2000

; Where the buffer to use for the test is.
BUF	= $3000



; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Code and Data

; Start 16 before the start for the ATR file header
.ORG START - 16

; *************************************************************************************************
; ATR file Header
	.WORD $0296 ; magic
	.WORD (END-START + 15)/16
	.WORD 128
	.WORD 0,0,0,0,0



; *************************************************************************************************
; Boot header
	.BYTE 0
	.BYTE (END-START + 127)/128
	.WORD START
	.WORD XRTS
       


; *************************************************************************************************
; Start
;Start:
	SEI
	LDA #0
	STA POKEY_W::IRQEN
	LDA #SKRECV
;	LDA #SKSEND
	STA POKEY_W::SKCTL
	STA POKEY_W::SKREST
	LDA #POKEY_AUDCTL::Link3And4 | POKEY_AUDCTL::Channel3Fast
	STA POKEY_W::AUDCTL
	LDA #$A0
	STA POKEY_W::AUDC4
	LDA #$28
;	LDA #4
;	LDA #0
	STA POKEY_W::AUDF3
	LDA #0
	STA POKEY_W::AUDF4

	LDA #$F8
	STA POKEY_W::IRQEN

	LDY #0
LOOP:
	LDA POKEY_R::IRQST
	STA $9C40
	LDA POKEY_R::SKSTAT
	STA $9C41
	JMP LOOP
; End Start



; *************************************************************************************************
; Just an RTS.
XRTS:
	RTS
; End XRTS



; *************************************************************************************************
.IF (* & 127)<>0
	.RES (128 - (* & 127)),0
.ENDIF

END:
